Package org.gradle.plugins.ear.descriptor

## Interface DeploymentDescriptor

-     public interface DeploymentDescriptor

  A deployment descriptor such as application.xml.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `String` | `getApplicationName()` | The application name.
    `String` | `getDescription()` | The application description.
    `String` | `getDisplayName()` | The application display name.
    `String` | `getFileName()` | The name of the descriptor file, typically "application.xml"
    `Boolean` | `getInitializeInOrder()` | Whether to initialize modules in the order they appear in the descriptor, with the exception of client modules.
    `String` | `getLibraryDirectory()` | The name of the directory to look for libraries in.
    `Set<EarModule>` | `getModules()` | List of module descriptors.
    `Map<String,​String>` | `getModuleTypeMappings()` | Mapping of module paths to module types.
    `Set<EarSecurityRole>` | `getSecurityRoles()` | List of security roles.
    `String` | `getVersion()` | The version of application.xml.
    `DeploymentDescriptor` | `module​(String path, String type)` | Add a module to the deployment descriptor.
    `DeploymentDescriptor` | `module​(EarModule module, String type)` | Add a module to the deployment descriptor.
    `DeploymentDescriptor` | `readFrom​(Reader reader)` | Reads the deployment descriptor from a reader.
    `boolean` | `readFrom​(Object path)` | Reads the deployment descriptor from a file.
    `DeploymentDescriptor` | `securityRole​(String role)` | Add a security role to the deployment descriptor.
    `DeploymentDescriptor` | `securityRole​(Action<? super EarSecurityRole> action)` | Add a security role to the deployment descriptor after configuring it with the given action.
    `DeploymentDescriptor` | `securityRole​(EarSecurityRole role)` | Add a security role to the deployment descriptor.
    `void` | `setApplicationName​(String applicationName)` |
    `void` | `setDescription​(String description)` |
    `void` | `setDisplayName​(String displayName)` |
    `void` | `setFileName​(String fileName)` |
    `void` | `setInitializeInOrder​(Boolean initializeInOrder)` |
    `void` | `setLibraryDirectory​(String libraryDirectory)` |
    `void` | `setModules​(Set<EarModule> modules)` |
    `void` | `setModuleTypeMappings​(Map<String,​String> moduleTypeMappings)` |
    `void` | `setSecurityRoles​(Set<EarSecurityRole> securityRoles)` |
    `void` | `setVersion​(String version)` |
    `DeploymentDescriptor` | `webModule​(String path, String contextRoot)` | Add a web module to the deployment descriptor.
    `DeploymentDescriptor` | `withXml​(Closure closure)` | Adds a closure to be called when the XML document has been created.
    `DeploymentDescriptor` | `withXml​(Action<? super XmlProvider> action)` | Adds an action to be called when the XML document has been created.
    `DeploymentDescriptor` | `writeTo​(Writer writer)` | Writes the deployment descriptor into a writer.
    `DeploymentDescriptor` | `writeTo​(Object path)` | Writes the deployment descriptor into a file.

- - ### Method Detail

    - #### getFileName

          String getFileName()

      The name of the descriptor file, typically "application.xml"

    - #### setFileName

          void setFileName​(String fileName)

    - #### getVersion

          String getVersion()

      The version of application.xml. Required. Valid versions are "1.3", "1.4", "5" and "6". Defaults to "6".

    - #### setVersion

          void setVersion​(String version)

    - #### getApplicationName

          String getApplicationName()

      The application name. Optional. Only valid with version 6.

    - #### setApplicationName

          void setApplicationName​(String applicationName)

    - #### getInitializeInOrder

          Boolean getInitializeInOrder()

      Whether to initialize modules in the order they appear in the descriptor, with the exception of client modules. Optional. Only valid with version 6.

    - #### setInitializeInOrder

          void setInitializeInOrder​(Boolean initializeInOrder)

    - #### getDescription

          String getDescription()

      The application description. Optional.

    - #### setDescription

          void setDescription​(String description)

    - #### getDisplayName

          String getDisplayName()

      The application display name. Optional.

    - #### setDisplayName

          void setDisplayName​(String displayName)

    - #### getLibraryDirectory

          String getLibraryDirectory()

      The name of the directory to look for libraries in. Optional. If not specified, `Ear.getLibDirName()` is used. Typically, this should be set via `EarPluginConvention.setLibDirName(String)` instead of this property when using the `ear` plugin.

    - #### setLibraryDirectory

          void setLibraryDirectory​(String libraryDirectory)

    - #### getModules

          Set<EarModule> getModules()

      List of module descriptors. Must not be empty. Non-null and order-maintaining by default. Must maintain order if initializeInOrder is `true`.

    - #### setModules

          void setModules​(Set<EarModule> modules)

    - #### module

          DeploymentDescriptor module​(EarModule module,
                                      String type)

      Add a module to the deployment descriptor.
      Parameters:
        `module` - The module to add.
        `type` - The type of the module, such as "ejb", "java", etc.
      Returns:
        this.

    - #### module

          DeploymentDescriptor module​(String path,
                                      String type)

      Add a module to the deployment descriptor.
      Parameters:
        `path` - The path of the module to add.
        `type` - The type of the module, such as "ejb", "java", etc.
      Returns:
        this.

    - #### webModule

          DeploymentDescriptor webModule​(String path,
                                         String contextRoot)

      Add a web module to the deployment descriptor.
      Parameters:
        `path` - The path of the module to add.
        `contextRoot` - The context root type of the web module.
      Returns:
        this.

    - #### getSecurityRoles

          Set<EarSecurityRole> getSecurityRoles()

      List of security roles. Optional. Non-null and order-maintaining by default.

    - #### setSecurityRoles

          void setSecurityRoles​(Set<EarSecurityRole> securityRoles)

    - #### securityRole

          DeploymentDescriptor securityRole​(EarSecurityRole role)

      Add a security role to the deployment descriptor.
      Parameters:
        `role` - The security role to add.
      Returns:
        this.

    - #### securityRole

          DeploymentDescriptor securityRole​(String role)

      Add a security role to the deployment descriptor.
      Parameters:
        `role` - The name of the security role to add.
      Returns:
        this.

    - #### securityRole

          DeploymentDescriptor securityRole​(Action<? super EarSecurityRole> action)

      Add a security role to the deployment descriptor after configuring it with the given action.
      Parameters:
        `action` - an action to configure the security role
      Returns:
        this.

    - #### getModuleTypeMappings

          Map<String,​String> getModuleTypeMappings()

      Mapping of module paths to module types. Non-null by default. For example, to specify that a module is a java module, set `moduleTypeMappings["myJavaModule.jar"] = "java"`.

    - #### setModuleTypeMappings

          void setModuleTypeMappings​(Map<String,​String> moduleTypeMappings)

    - #### withXml

          DeploymentDescriptor withXml​(Closure closure)

      Adds a closure to be called when the XML document has been created. The XML is passed to the closure as a parameter in form of a `Node`. The closure can modify the XML before it is written to the output file. This allows additional JavaEE version 6 elements like "data-source" or "resource-ref" to be included.
      Parameters:
        `closure` - The closure to execute when the XML has been created
      Returns:
        this

    - #### withXml

          DeploymentDescriptor withXml​(Action<? super XmlProvider> action)

      Adds an action to be called when the XML document has been created. The XML is passed to the action as a parameter in form of a `Node`. The action can modify the XML before it is written to the output file. This allows additional JavaEE version 6 elements like "data-source" or "resource-ref" to be included.
      Parameters:
        `action` - The action to execute when the XML has been created
      Returns:
        this

    - #### readFrom

          DeploymentDescriptor readFrom​(Reader reader)

      Reads the deployment descriptor from a reader.
      Parameters:
        `reader` - The reader to read the deployment descriptor from
      Returns:
        this

    - #### readFrom

          boolean readFrom​(Object path)

      Reads the deployment descriptor from a file. The paths are resolved as defined by `Project.file(Object)`
      Parameters:
        `path` - The path of the file to read the deployment descriptor from
      Returns:
        whether the descriptor could be read from the given path

    - #### writeTo

          DeploymentDescriptor writeTo​(Writer writer)

      Writes the deployment descriptor into a writer.
      Parameters:
        `writer` - The writer to write the deployment descriptor to
      Returns:
        this

    - #### writeTo

          DeploymentDescriptor writeTo​(Object path)

      Writes the deployment descriptor into a file. The paths are resolved as defined by `Project.file(Object)`
      Parameters:
        `path` - The path of the file to write the deployment descriptor into.
      Returns:
        this